﻿Option Strict On
Option Explicit On

Imports ESRI.ArcGIS.ArcMapUI
Imports ESRI.ArcGIS.Carto
Imports ESRI.ArcGIS.Geodatabase
Imports ESRI.ArcGIS.esriSystem
Imports ESRI.ArcGIS.Framework
Imports ESRI.ArcGIS.Geometry
Imports ESRI.ArcGIS.Display
Module Calculate1
    Public Function EC_CalculateG(ByVal pInFL As IFeatureLayer, ByVal sFieldName As String, ByVal sExpression As String) As Boolean
        Dim pTrackCancel As ITrackCancel = New CancelTracker
        Dim pProgressDlgFact As IProgressDialogFactory = New ProgressDialogFactory
        Dim pProgressDialog As IProgressDialog2 = CType(pProgressDlgFact.Create(pTrackCancel, 0), IProgressDialog2)
        Dim pStepProgressor As IStepProgressor = CType(pProgressDialog, IStepProgressor)
        Dim bContinue As Boolean = True
        Dim ECE As New ECGeometryExpressions
        Try
            Dim pFeature As IFeature
            Dim pGeometry As IGeometry
            Dim pFeatureCursor As IFeatureCursor
            Dim k As Long
            Dim lCount As Integer
            Dim pSel As IFeatureSelection = CType(pInFL, IFeatureSelection)
            Dim pInFeatureClass As IFeatureClass = pInFL.FeatureClass
            Dim pSelSet As ISelectionSet2 = CType(pSel.SelectionSet, ISelectionSet2)
            lCount = pSelSet.Count
            If lCount = 0 Then
                pFeatureCursor = pInFeatureClass.Update(Nothing, False)
                lCount = pInFeatureClass.FeatureCount(Nothing)
            Else
                Dim pCursor As ICursor = Nothing
                pSelSet.Update(Nothing, False, pCursor)
                pFeatureCursor = CType(pCursor, IFeatureCursor)
            End If

            Dim iFi As Integer = pInFeatureClass.FindField(sFieldName)
            If iFi = -1 Then
                MsgBox("Field not found!")
                Return False
            End If
            Dim iStep As Integer = EC_GetStep(lCount)
            pTrackCancel.CheckTime = 10
            With pProgressDialog
                .CancelEnabled = True
                .Description = "Calculating..."
                .Title = "EeasyCalculate"
                .Animation = ESRI.ArcGIS.Framework.esriProgressAnimationTypes.esriProgressGlobe
            End With
            With pStepProgressor
                .MinRange = 0
                .MaxRange = lCount
                .StepValue = iStep
            End With
            pFeature = pFeatureCursor.NextFeature
            k = 0
            Do While Not pFeature Is Nothing
                If k Mod iStep = 0 Then
                    pStepProgressor.Message = k & " of " & lCount & " Features processed"
                    bContinue = pTrackCancel.Continue
                    pStepProgressor.Step()
                    If Not bContinue Then Exit Do
                End If
                If Not pFeature.Shape Is Nothing Then
                    pGeometry = pFeature.ShapeCopy
                    If (Not pGeometry.IsEmpty) Then
                        params.Geometry = pGeometry
                        pFeature.Value(iFi) = CallByName(ECE, sExpression, CallType.Method)
                        pFeatureCursor.UpdateFeature(pFeature)
                    End If 'empty
                End If 'nothing
                pFeature = pFeatureCursor.NextFeature
                k = k + 1
            Loop

            If (Not bContinue) Then
                Return False
            End If
            Return True
        Catch
            MsgBox(Err.Description)
            Return False
        Finally
            pProgressDialog.HideDialog()
            pTrackCancel = Nothing
            pProgressDlgFact = Nothing
            pProgressDialog = Nothing
            pStepProgressor = Nothing
        End Try
    End Function
    Public Function EC_CalculateD(ByVal pInFL As IFeatureLayer, ByVal sFieldName As String, ByVal sExpression As String) As Boolean
        Dim pTrackCancel As ITrackCancel = New CancelTracker
        Dim pProgressDlgFact As IProgressDialogFactory = New ProgressDialogFactory
        Dim pProgressDialog As IProgressDialog2 = CType(pProgressDlgFact.Create(pTrackCancel, 0), IProgressDialog2)
        Dim pStepProgressor As IStepProgressor = CType(pProgressDialog, IStepProgressor)
        Dim bContinue As Boolean = True
        Dim ECE As New ECDrawExpressions
        Dim bRecord As Boolean
        Dim iDummy As Object
        Try
            Dim pFeature As IFeature
            Dim pGeometry As IGeometry
            Dim pFeatureCursor As IFeatureCursor
            Dim k As Long
            Dim lCount As Integer
            Dim pSel As IFeatureSelection = CType(pInFL, IFeatureSelection)
            Dim pInFeatureClass As IFeatureClass = pInFL.FeatureClass
            Dim pSelSet As ISelectionSet2 = CType(pSel.SelectionSet, ISelectionSet2)
            lCount = pSelSet.Count
            If lCount = 0 Then
                pFeatureCursor = pInFeatureClass.Update(Nothing, False)
                lCount = pInFeatureClass.FeatureCount(Nothing)
            Else
                Dim pCursor As ICursor = Nothing
                pSelSet.Update(Nothing, False, pCursor)
                pFeatureCursor = CType(pCursor, IFeatureCursor)
            End If

            Dim iFi As Integer = pInFeatureClass.FindField(sFieldName)
            If iFi = -1 Then
                bRecord = False
            Else
                bRecord = True
            End If
            Dim iStep As Integer = EC_GetStep(lCount)
            pTrackCancel.CheckTime = 10
            With pProgressDialog
                .CancelEnabled = True
                .Description = "Calculating..."
                .Title = "EeasyCalculate"
                .Animation = ESRI.ArcGIS.Framework.esriProgressAnimationTypes.esriProgressGlobe
            End With
            With pStepProgressor
                .MinRange = 0
                .MaxRange = lCount
                .StepValue = iStep
            End With
            pFeature = pFeatureCursor.NextFeature
            k = 0
            Do While Not pFeature Is Nothing
                If k Mod iStep = 0 Then
                    pStepProgressor.Message = k & " of " & lCount & " Features processed"
                    bContinue = pTrackCancel.Continue
                    pStepProgressor.Step()
                    If Not bContinue Then Exit Do
                End If
                If Not pFeature.Shape Is Nothing Then
                    pGeometry = pFeature.ShapeCopy
                    If (Not pGeometry.IsEmpty) Then
                        params.Geometry = pGeometry
                        If bRecord Then
                            pFeature.Value(iFi) = CallByName(ECE, sExpression, CallType.Method)
                            pFeatureCursor.UpdateFeature(pFeature)
                        Else
                            iDummy = CallByName(ECE, sExpression, CallType.Method)
                        End If
                       
                    End If 'empty
                End If 'nothing
                pFeature = pFeatureCursor.NextFeature
                k = k + 1
            Loop

            If (Not bContinue) Then
                Return False
            End If
            Dim pActiveView As IActiveView = CType(My.Document.FocusMap, IActiveView)
            Dim pEnv As IEnvelope = pActiveView.Extent
            pActiveView.PartialRefresh(esriViewDrawPhase.esriViewBackground, Nothing, pEnv)
            Return True
        Catch
            MsgBox(Err.Description)
            Return False
        Finally
            pProgressDialog.HideDialog()
            pTrackCancel = Nothing
            pProgressDlgFact = Nothing
            pProgressDialog = Nothing
            pStepProgressor = Nothing
        End Try
    End Function
    Public Function EC_CalculateE(ByVal pInFL As IFeatureLayer, ByVal sFieldName As String, ByVal sExpression As String) As Boolean
        Dim pTrackCancel As ITrackCancel = New CancelTracker
        Dim pProgressDlgFact As IProgressDialogFactory = New ProgressDialogFactory
        Dim pProgressDialog As IProgressDialog2 = CType(pProgressDlgFact.Create(pTrackCancel, 0), IProgressDialog2)
        Dim pStepProgressor As IStepProgressor = CType(pProgressDialog, IStepProgressor)
        Dim bContinue As Boolean = True
        Dim ECE As New ECEditExpressions
        Dim bRecord As Boolean
        Dim pNewGeometry As IGeometry
        Try
            Dim pFeature As IFeature
            Dim pGeometry As IGeometry
            Dim pFeatureCursor As IFeatureCursor
            Dim k As Long
            Dim lCount As Integer
            Dim pSel As IFeatureSelection = CType(pInFL, IFeatureSelection)
            Dim pInFeatureClass As IFeatureClass = pInFL.FeatureClass
            Dim pSelSet As ISelectionSet2 = CType(pSel.SelectionSet, ISelectionSet2)
            lCount = pSelSet.Count
            If lCount = 0 Then
                pFeatureCursor = pInFeatureClass.Update(Nothing, False)
                lCount = pInFeatureClass.FeatureCount(Nothing)
            Else
                Dim pCursor As ICursor = Nothing
                pSelSet.Update(Nothing, False, pCursor)
                pFeatureCursor = CType(pCursor, IFeatureCursor)
            End If

            Dim iFi As Integer = pInFeatureClass.FindField(sFieldName)
            If iFi = -1 Then
                bRecord = False
            Else
                bRecord = True
            End If
            Dim iStep As Integer = EC_GetStep(lCount)
            pTrackCancel.CheckTime = 10
            With pProgressDialog
                .CancelEnabled = True
                .Description = "Calculating..."
                .Title = "EeasyCalculate"
                .Animation = ESRI.ArcGIS.Framework.esriProgressAnimationTypes.esriProgressGlobe
            End With
            With pStepProgressor
                .MinRange = 0
                .MaxRange = lCount
                .StepValue = iStep
            End With
            pFeature = pFeatureCursor.NextFeature
            k = 0
            Do While Not pFeature Is Nothing
                If k Mod iStep = 0 Then
                    pStepProgressor.Message = k & " of " & lCount & " Features processed"
                    bContinue = pTrackCancel.Continue
                    pStepProgressor.Step()
                    If Not bContinue Then Exit Do
                End If
                If Not pFeature.Shape Is Nothing Then
                    pGeometry = pFeature.ShapeCopy
                    If (Not pGeometry.IsEmpty) Then
                        params.Geometry = pGeometry
                        pNewGeometry = CType(CallByName(ECE, sExpression, CallType.Method), IGeometry)
                        If pNewGeometry Is Nothing Then
                            If bRecord Then
                                pFeature.Value(iFi) = 0
                            End If
                        Else
                            If bRecord Then
                                pFeature.Value(iFi) = 1
                            End If
                            pFeature.Shape = pNewGeometry
                        End If
                        pFeatureCursor.UpdateFeature(pFeature)
                    End If 'empty
                End If 'nothing
                pFeature = pFeatureCursor.NextFeature
                k = k + 1
            Loop

            If (Not bContinue) Then
                Return False
            End If
            Dim pActiveView As IActiveView = CType(My.Document.FocusMap, IActiveView)
            Dim pEnv As IEnvelope = pActiveView.Extent
            pActiveView.PartialRefresh(esriViewDrawPhase.esriViewBackground, Nothing, pEnv)
            Return True
        Catch
            MsgBox(Err.Description)
            Return False
        Finally
            pProgressDialog.HideDialog()
            pTrackCancel = Nothing
            pProgressDlgFact = Nothing
            pProgressDialog = Nothing
            pStepProgressor = Nothing
        End Try
    End Function
    
End Module
